#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/resource.h>

#include "gpio.h"
#include "i2c.h"

int verbose;
static int zone = 1;

static int
get_status ()
{
  char msgbuf[1];
  i2c(zone, 2, 0, msgbuf, 1);
  return msgbuf[0];
}

int
main(int argc, char **argv)
{
  int i, wi=0, ri=0;
  int fill_time, mark_time, empty_time;
  int buf_size = 0;
  int tried = 0;

  //setbuf(stdout, 0);

  i2c_open ();

  while (1)
    {
      if (i2c(zone, 5, 1, " ", 1))
	{
	  printf("bad, trying to fix, try %d\n");
	  switch (tried++)
	    {
	    case 0:
	    case 1:
	    case 2:
	      i2c_close ();
	      i2c_open ();
	      break;
	    default:
	      printf("giving up, exiting\n");
	      exit(1);
	    }
	}
      else
	tried = 0;
    }
  fill_time = msclock();
  while (!buffer_room())
    ;
  mark_time = msclock();
  while (!buffer_empty())
    ;
  empty_time = msclock();

  printf("buffer %d fill %d mark %d empty %d\n",
	 buf_size, fill_time, mark_time, empty_time);

  i2c_close ();
  return 0;
}
