#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/resource.h>

#include <linux/i2c.h>
#include <linux/i2c-dev.h>

#include "gpio.h"

static int i2c_fd;

#define Z1_RESET	64
#define ZP_MODE		61

main(int argc, char **argv)
{
  int addr = 0x2d;
  struct i2c_msg msg[2];
  struct i2c_rdwr_ioctl_data mlist;
  int i2c, i;
  char msgbuf[4] = { 0, 1, 0, 0 };
  char rdbuf[4] = { 0, 1, 0, 0 };

  gpio_setup ();

  setbuf(stdout, 0);
  i2c_fd = open("/dev/i2c-0", O_RDWR);
  if (i2c_fd < 0)
    {
      perror ("/dev/i2c-0");
      exit (1);
    }

  if (argc > 1)
    addr = strtol(argv[1], 0, 16);
  printf("addr: 0x%02x\n", addr);

  msg[0].addr = addr;
  msg[0].flags = 0;
  msg[0].len = 2;
  msg[0].buf = msgbuf;

  msg[1].addr = addr;
  msg[1].flags = I2C_M_RD;
  msg[1].len = 4;
  msg[1].buf = rdbuf;

  mlist.msgs = msg;
  mlist.nmsgs = 2;

  while (1)
    {
      msg[1].len = 4;
      memset (rdbuf, 0, 4);
      if (ioctl (i2c, I2C_RDWR, &mlist) < 0)
	{
	  perror("ioctl");
	  printf("last count: %02x %02x %02x %02x\n",
		 msgbuf[3], msgbuf[2], msgbuf[1], msgbuf[0]);
	  system("date");
	  exit(1);
	}

      printf("read count %d bytes %02x %02x %02x %02x\n",
	     msg[1].len,
	     rdbuf[0], rdbuf[1], rdbuf[2], rdbuf[3]);

      for (i=1; i<4; i++)
	{
	  msg[0].buf[i] ++;
	  if (msg[0].buf[i] != 0)
	    break;
	}
      //      sleep (1);
    }

  close (i2c);
  return 0;
}
