#include <stdio.h>
#include <getopt.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/resource.h>

#include "serial.h"
#include "r8c-bits.h"
#include "gpio.h"

int verbose;

#define Z1_RESET	64
#define ZP_MODE		61

static int zone_resets[] = { 64, 65, 66, 67, 68 };

int
main (int argc, char **argv)
{
  int i, o;
  char *fname;
  FILE *f;
  unsigned char buf[256];
  int pageno;
  int hold = 0;

  gpio_setup ();

  for (i=0; i<5; i++)
    gpio_set_mode (zone_resets[i], GPIO_MODE_WRITE, GPIO_MODE_GPIO);
  gpio_set_mode (ZP_MODE, GPIO_MODE_WRITE, GPIO_MODE_GPIO);


  gpio_write (ZP_MODE, 1);
  for (i=1; i<argc; i++)
    {
      if (strcmp(argv[i], "-h") == 0)
	hold = 1;
      else
	{
	  o = atoi(argv[i]);
	  if (o >= 1 && o <= 5)
	    {
	      gpio_write (zone_resets[o-1], 0);
	      mspause(1);
	      if (!hold)
		gpio_write (zone_resets[o-1], 1);
	    }
	  else
	    printf("Zone %s ignored, not 1..5\n", argv[i]);
	}
    }
  return 0;
}
