.include "r8c-ports.S"

	.data

	.global	_ac_clock
_ac_clock:
	.short	0, 0

_ac_watchdog:
	.short	0

	.text

	.global	_ac_init
_ac_init:
	;; set up timer B
	bset	_tstop,trbcr	; reset
	mov.b	#0x0a,trbmr	; one-shot mode, 20MHz
	mov.b	#0x00,trbioc	; no external trigger
	mov.b	#19,trbpre	; 1uS per clock
	mov.b	#230,trbpr	; 250uS timeout
	mov.w	#_irq_timerb,ivect_timerz ; shared
	bset	_tstart,trbcr	; start timer b
	mov.b	#0x05,trbic
	
	;; set up timer A to about 600Hz
	mov.b	#0x00,traioc	; I/O for timer mode
	mov.b	#0x00,tramr	; timer mode, 20 MHz
	mov.b	#0x00,tracr	; stop count
	mov.b	#255,trapre	; prescale to 78,125 Hz
	mov.b	#130,tra	; scale to 600 Hz
	mov.w	#_irq_timera,ivect_timera
	bset	_tstart,tracr	; start timer A
	mov.b	#0x05,traic

	;; set up INT1
	bset	_int1sel,pmr	; put INT1 on P3.6
	bset	_int1en,inten	; enable, one edge.
	mov.b	#0x45,intf	; filter with f1 sampling
	mov.b	#0x15,int1ic	; enable on rising edge

	mov.w	#_irq_int1,irq_vector+0x64
	rts

_irq_int1:
	bset	_tosst,trbocr	; start timer b
	add.w	#1,_ac_clock
	adcf.w	_ac_clock+2
	mov.w	#0,_ac_watchdog
	and.b	#0xef,_status_byte
	reit

_irq_timerb:
	mov.b	_p0_bits,p0
	mov.b	_p1_bits,p1
	reit

	;; timer A interrupts about 600 times a second.  Thus, we
	;; count about 10 times per AC power cycle.  This is often
	;; enough to get within 10% of accurately measuring time, yet
	;; gives us 6533 seconds (over an hour and a half) to notice
	;; that we have no power.  Testing shows that we only last a
	;; second or two anyway.

_irq_timera:
	add.w	#1,_ac_watchdog
	cmp.w	#40,_ac_watchdog
	jlt	_power_ok
	or.b	#0x10,_status_byte
_power_ok:	
	reit
