#include <stdarg.h>

#include "console.h"
#include "r8c-ports.h"
#include "globals.h"
#include "fix.h"
#include "i2c.h"
#include "msec.h"

static char user_leds = 0;
static char app_leds = 0;
static char p1_leds = 0;

static void
leds_update ()
{
  p1_leds = ~(user_leds^app_leds);
  p1_bits &= 0xf8;
  p1_bits |= (p1_leds & 0x07);
  /*  printf("leds: u %b a %b l %b p %b\n", user_leds, app_leds, p1_leds, p1_bits);*/
  p1 = p1_bits;
}

static void
leds_rx (unsigned char b)
{
  user_leds = b;
  /*leds_update ();*/
}

static const i2c_setup_struct leds_command = {
  0, leds_rx, 0, 0, 0
};

leds_init ()
{
  i2c_register_command (1, &leds_command);
}

void
led_on(int mask)
{
#if 0
  app_leds |= mask;
  leds_update ();
#endif
  p1_bits &= ~mask;
  p1 = p1_bits;
}

void
led_off(int mask)
{
#if 0
  app_leds &= ~mask;
  leds_update ();
#endif
  p1_bits |= mask;
  p1 = p1_bits;
}
