/* R5F211B4DSP - R8C/1B 16k flash, 1k ram */

OUTPUT_FORMAT("elf32-m32c", "elf32-m32c",
	      "elf32-m32c")
OUTPUT_ARCH(m32c)
ENTRY(_start)

MEMORY {
	RAM (w) : ORIGIN = 0x400, LENGTH = 0x400
	ROM (r) : ORIGIN = 0xc000, LENGTH = 0x3f24
	UND (r) : ORIGIN = 0xff00, LENGTH = 0xdc
	VEC (r) : ORIGIN = 0xffdc, LENGTH = 32
	RESETVEC (r) : ORIGIN = 0xfffc, LENGTH = 4
}
SECTIONS
{
  .text : {
    *(.text)
    PROVIDE (__etext = .);
    . = ALIGN(2);
    *(.rodata*)
    . = ALIGN(2);
    __romdatastart = .;
  } > ROM =0

  .data : {
    __datastart = .;
    . = ALIGN(2);
    *(.data)
    . = ALIGN(2);
    _edata = .;
  } > RAM AT>ROM
  PROVIDE (__romdatacopysize = SIZEOF(.data));

  .bss : {
    . = ALIGN(2);
    PROVIDE (__bssstart = .);
    *(.bss)
    *(COMMON)
    . = ALIGN(2);
    PROVIDE (__bssend = .);
  } > RAM
  __bsssize = SIZEOF(.bss);

  .stack (0x7fe) :
  {
    PROVIDE (__stack = .);
    *(.stack)
  }

  .und : {
    *(.und)
  } > UND
  .vec : {
    *(.vec)
  } > VEC
  .resetvec : {
    *(.resetvec)
  } > RESETVEC
}
