#include "console.h"
#include "r8c-ports.h"
#include "globals.h"

#include "i2c.h"

volatile byte p0_bits = 0;
volatile byte p1_bits = 0;

volatile extern int ac_clock;

int rx_count;

static void
furnace_rx_start ()
{
  rx_count = 0;
}

static void
furnace_rx (unsigned char b)
{
  switch (rx_count)
    {
    case 0:
      p1_bits = b;
      break;
    case 1:
      p0_bits = b;
      break;
    }
  rx_count ++;
}

static i2c_setup_struct furnace_command = {
  furnace_rx_start,
  furnace_rx,
  0, 0, 0
};

static i2c_setup_struct acclock_command = {
  0, 0, 0,
  &ac_clock, 4
};

static void
ac_wait(int cyc)
{
  int start = ac_clock;
  while (ac_clock - start < cyc)
    ;
}

main()
{
  int i = 0;

  prcr.prc2 = 1; /* enable pd0 */
  pd0 = 0xff; /* opto output */
  pd1 = 0xff; /* opto output */
  pd3 = 0x00; /* input */
  pd4 = 0x00; /* input */

  i2c_init ();
  console_init ();
  ac_init ();

  i2c_register_command (4, &furnace_command);
  i2c_register_command (7, &acclock_command);

  printf("\033[34mR8C Furnace Monitor\033[0m\n");

  p0_bits = 0xaa; /* all zones open */
  p1_bits = 0x0c; /* furnace off, both aux on */

#if 0
  while (1)
    {
      p1_bits = 0xff;
      p0_bits = 0xff;
      ac_wait(30);
      p1_bits = 0xaa;
      p0_bits = 0xaa;
      ac_wait(30);
      p1_bits = 0x55;
      p0_bits = 0x55;
      ac_wait(30);
    }
#endif

#if 0
  i = 0x0f;
  while (1)
    {
      i = (i << 1) | ((i>>18) & 1);
      if ((i & 0x3fff) == 0)
	i = 1;

      p1_bits = ((i>>4) & 0xf0) | ((i>>10) & 0x0c);
      p0_bits = i;

      ac_wait(1);
    }

#endif

  while (1)
    asm("wait");
}

